<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunYorum ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunYorum
 * @subpackage Arrays
 */
class ArrayOfUrunYorum extends AbstractStructArrayBase
{
    /**
     * The UrunYorum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunYorum[]
     */
    public $UrunYorum;
    /**
     * Constructor method for ArrayOfUrunYorum
     * @uses ArrayOfUrunYorum::setUrunYorum()
     * @param \StructType\UrunYorum[] $urunYorum
     */
    public function __construct(array $urunYorum = array())
    {
        $this
            ->setUrunYorum($urunYorum);
    }
    /**
     * Get UrunYorum value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunYorum[]|null
     */
    public function getUrunYorum()
    {
        return isset($this->UrunYorum) ? $this->UrunYorum : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunYorum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunYorum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunYorumForArrayConstraintsFromSetUrunYorum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunYorumUrunYorumItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunYorumUrunYorumItem instanceof \StructType\UrunYorum) {
                $invalidValues[] = is_object($arrayOfUrunYorumUrunYorumItem) ? get_class($arrayOfUrunYorumUrunYorumItem) : sprintf('%s(%s)', gettype($arrayOfUrunYorumUrunYorumItem), var_export($arrayOfUrunYorumUrunYorumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunYorum property can only contain items of type \StructType\UrunYorum, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunYorum value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunYorum[] $urunYorum
     * @return \ArrayType\ArrayOfUrunYorum
     */
    public function setUrunYorum(array $urunYorum = array())
    {
        // validation for constraint: array
        if ('' !== ($urunYorumArrayErrorMessage = self::validateUrunYorumForArrayConstraintsFromSetUrunYorum($urunYorum))) {
            throw new \InvalidArgumentException($urunYorumArrayErrorMessage, __LINE__);
        }
        if (is_null($urunYorum) || (is_array($urunYorum) && empty($urunYorum))) {
            unset($this->UrunYorum);
        } else {
            $this->UrunYorum = $urunYorum;
        }
        return $this;
    }
    /**
     * Add item to UrunYorum value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunYorum $item
     * @return \ArrayType\ArrayOfUrunYorum
     */
    public function addToUrunYorum(\StructType\UrunYorum $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunYorum) {
            throw new \InvalidArgumentException(sprintf('The UrunYorum property can only contain items of type \StructType\UrunYorum, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunYorum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunYorum|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunYorum|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunYorum|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunYorum|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunYorum|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunYorum
     */
    public function getAttributeName()
    {
        return 'UrunYorum';
    }
}
