<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UrunKartiVideo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UrunKartiVideo
 * @subpackage Structs
 */
class UrunKartiVideo extends AbstractStructBase
{
    /**
     * The OtomatikOynat
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $OtomatikOynat;
    /**
     * The TumKontrolleriGoster
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $TumKontrolleriGoster;
    /**
     * The UrunDetayVideoAyar
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunDetayVideoAyar
     */
    public $UrunDetayVideoAyar;
    /**
     * The UrunListedeGoster
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $UrunListedeGoster;
    /**
     * The VideoLink
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VideoLink;
    /**
     * The VideoSesAktif
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $VideoSesAktif;
    /**
     * The VideoTagTipi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VideoTagTipi;
    /**
     * Constructor method for UrunKartiVideo
     * @uses UrunKartiVideo::setOtomatikOynat()
     * @uses UrunKartiVideo::setTumKontrolleriGoster()
     * @uses UrunKartiVideo::setUrunDetayVideoAyar()
     * @uses UrunKartiVideo::setUrunListedeGoster()
     * @uses UrunKartiVideo::setVideoLink()
     * @uses UrunKartiVideo::setVideoSesAktif()
     * @uses UrunKartiVideo::setVideoTagTipi()
     * @param bool $otomatikOynat
     * @param bool $tumKontrolleriGoster
     * @param \StructType\UrunDetayVideoAyar $urunDetayVideoAyar
     * @param bool $urunListedeGoster
     * @param string $videoLink
     * @param bool $videoSesAktif
     * @param string $videoTagTipi
     */
    public function __construct($otomatikOynat = null, $tumKontrolleriGoster = null, \StructType\UrunDetayVideoAyar $urunDetayVideoAyar = null, $urunListedeGoster = null, $videoLink = null, $videoSesAktif = null, $videoTagTipi = null)
    {
        $this
            ->setOtomatikOynat($otomatikOynat)
            ->setTumKontrolleriGoster($tumKontrolleriGoster)
            ->setUrunDetayVideoAyar($urunDetayVideoAyar)
            ->setUrunListedeGoster($urunListedeGoster)
            ->setVideoLink($videoLink)
            ->setVideoSesAktif($videoSesAktif)
            ->setVideoTagTipi($videoTagTipi);
    }
    /**
     * Get OtomatikOynat value
     * @return bool|null
     */
    public function getOtomatikOynat()
    {
        return $this->OtomatikOynat;
    }
    /**
     * Set OtomatikOynat value
     * @param bool $otomatikOynat
     * @return \StructType\UrunKartiVideo
     */
    public function setOtomatikOynat($otomatikOynat = null)
    {
        // validation for constraint: boolean
        if (!is_null($otomatikOynat) && !is_bool($otomatikOynat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($otomatikOynat, true), gettype($otomatikOynat)), __LINE__);
        }
        $this->OtomatikOynat = $otomatikOynat;
        return $this;
    }
    /**
     * Get TumKontrolleriGoster value
     * @return bool|null
     */
    public function getTumKontrolleriGoster()
    {
        return $this->TumKontrolleriGoster;
    }
    /**
     * Set TumKontrolleriGoster value
     * @param bool $tumKontrolleriGoster
     * @return \StructType\UrunKartiVideo
     */
    public function setTumKontrolleriGoster($tumKontrolleriGoster = null)
    {
        // validation for constraint: boolean
        if (!is_null($tumKontrolleriGoster) && !is_bool($tumKontrolleriGoster)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($tumKontrolleriGoster, true), gettype($tumKontrolleriGoster)), __LINE__);
        }
        $this->TumKontrolleriGoster = $tumKontrolleriGoster;
        return $this;
    }
    /**
     * Get UrunDetayVideoAyar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunDetayVideoAyar|null
     */
    public function getUrunDetayVideoAyar()
    {
        return isset($this->UrunDetayVideoAyar) ? $this->UrunDetayVideoAyar : null;
    }
    /**
     * Set UrunDetayVideoAyar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UrunDetayVideoAyar $urunDetayVideoAyar
     * @return \StructType\UrunKartiVideo
     */
    public function setUrunDetayVideoAyar(\StructType\UrunDetayVideoAyar $urunDetayVideoAyar = null)
    {
        if (is_null($urunDetayVideoAyar) || (is_array($urunDetayVideoAyar) && empty($urunDetayVideoAyar))) {
            unset($this->UrunDetayVideoAyar);
        } else {
            $this->UrunDetayVideoAyar = $urunDetayVideoAyar;
        }
        return $this;
    }
    /**
     * Get UrunListedeGoster value
     * @return bool|null
     */
    public function getUrunListedeGoster()
    {
        return $this->UrunListedeGoster;
    }
    /**
     * Set UrunListedeGoster value
     * @param bool $urunListedeGoster
     * @return \StructType\UrunKartiVideo
     */
    public function setUrunListedeGoster($urunListedeGoster = null)
    {
        // validation for constraint: boolean
        if (!is_null($urunListedeGoster) && !is_bool($urunListedeGoster)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($urunListedeGoster, true), gettype($urunListedeGoster)), __LINE__);
        }
        $this->UrunListedeGoster = $urunListedeGoster;
        return $this;
    }
    /**
     * Get VideoLink value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVideoLink()
    {
        return isset($this->VideoLink) ? $this->VideoLink : null;
    }
    /**
     * Set VideoLink value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $videoLink
     * @return \StructType\UrunKartiVideo
     */
    public function setVideoLink($videoLink = null)
    {
        // validation for constraint: string
        if (!is_null($videoLink) && !is_string($videoLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($videoLink, true), gettype($videoLink)), __LINE__);
        }
        if (is_null($videoLink) || (is_array($videoLink) && empty($videoLink))) {
            unset($this->VideoLink);
        } else {
            $this->VideoLink = $videoLink;
        }
        return $this;
    }
    /**
     * Get VideoSesAktif value
     * @return bool|null
     */
    public function getVideoSesAktif()
    {
        return $this->VideoSesAktif;
    }
    /**
     * Set VideoSesAktif value
     * @param bool $videoSesAktif
     * @return \StructType\UrunKartiVideo
     */
    public function setVideoSesAktif($videoSesAktif = null)
    {
        // validation for constraint: boolean
        if (!is_null($videoSesAktif) && !is_bool($videoSesAktif)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($videoSesAktif, true), gettype($videoSesAktif)), __LINE__);
        }
        $this->VideoSesAktif = $videoSesAktif;
        return $this;
    }
    /**
     * Get VideoTagTipi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVideoTagTipi()
    {
        return isset($this->VideoTagTipi) ? $this->VideoTagTipi : null;
    }
    /**
     * Set VideoTagTipi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $videoTagTipi
     * @return \StructType\UrunKartiVideo
     */
    public function setVideoTagTipi($videoTagTipi = null)
    {
        // validation for constraint: string
        if (!is_null($videoTagTipi) && !is_string($videoTagTipi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($videoTagTipi, true), gettype($videoTagTipi)), __LINE__);
        }
        if (is_null($videoTagTipi) || (is_array($videoTagTipi) && empty($videoTagTipi))) {
            unset($this->VideoTagTipi);
        } else {
            $this->VideoTagTipi = $videoTagTipi;
        }
        return $this;
    }
}
